package net.mcreator.superbwarfare.entity.model;

import net.mcreator.superbwarfare.ModUtils;
import net.mcreator.superbwarfare.entity.projectile.ProjectileEntity;
import net.mcreator.superbwarfare.init.ModItems;
import net.minecraft.client.Minecraft;
import net.minecraft.resources.ResourceLocation;
import net.minecraft.world.entity.player.Player;
import org.lwjgl.glfw.GLFW;
import software.bernie.geckolib.core.animatable.model.CoreGeoBone;
import software.bernie.geckolib.core.animation.AnimationState;
import software.bernie.geckolib.model.GeoModel;

public class ProjectileEntityModel extends GeoModel<ProjectileEntity> {
    @Override
    public ResourceLocation getAnimationResource(ProjectileEntity entity) {
        return null;
    }

    @Override
    public ResourceLocation getModelResource(ProjectileEntity entity) {
        Player player = Minecraft.getInstance().player;
        if (player == null) {
            return new ResourceLocation(ModUtils.MODID, "geo/projectile_entity2.geo.json");
        }

        if (GLFW.glfwGetMouseButton(Minecraft.getInstance().getWindow().getWindow(), GLFW.GLFW_MOUSE_BUTTON_RIGHT) == GLFW.GLFW_PRESS
                || player.getMainHandItem().is(ModItems.GLOCK_17.get())
                || player.getMainHandItem().is(ModItems.GLOCK_18.get())
                || player.getMainHandItem().is(ModItems.BOCEK.get())) {
            return new ResourceLocation(ModUtils.MODID, "geo/projectile_entity.geo.json");
        } else {
            return new ResourceLocation(ModUtils.MODID, "geo/projectile_entity2.geo.json");
        }
    }

    @Override
    public ResourceLocation getTextureResource(ProjectileEntity entity) {
        return new ResourceLocation(ModUtils.MODID, "textures/entity/empty.png");
    }

    @Override
    public void setCustomAnimations(ProjectileEntity animatable, long instanceId, AnimationState animationState) {
        CoreGeoBone bone = getAnimationProcessor().getBone("bone");
        bone.setHidden(animatable.tickCount <= 1);
    }
}
